<?php
/*
 You may not change or alter any portion of this comment or credits
 of supporting developers from this source code or any supporting source code
 which is considered copyrighted (c) material of the original comment or credit authors.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*/

/**
 * Team module for xoops
 *
 * @copyright      2020 XOOPS Project (https://xooops.org)
 * @license        GPL 2.0 or later
 * @package        team
 * @since          1.0
 * @min_xoops      2.5.9
 * @author         B.Heyula - Email:<b.heyula@hotmail.com> - Website:<http://erenyumak.com>
 */

use Xmf\Request;
use XoopsModules\Team;
use XoopsModules\Team\Constants;

require __DIR__ . '/header.php';
$GLOBALS['xoopsOption']['template_main'] = 'team_index.tpl';
include_once XOOPS_ROOT_PATH . '/header.php';
// Define Stylesheet
$GLOBALS['xoTheme']->addStylesheet($style, null);
$keywords = [];
// 
$GLOBALS['xoopsTpl']->assign('xoops_icons32_url', XOOPS_ICONS32_URL);
$GLOBALS['xoopsTpl']->assign('team_url', TEAM_URL);
// 
$teamsCount = $teamsHandler->getCountTeams();
$GLOBALS['xoopsTpl']->assign('teamsCount', $teamsCount);
$count = 1;
if ($teamsCount > 0) {
	$start = Request::getInt('start', 0);
	$limit = Request::getInt('limit', $helper->getConfig('userpager'));
	$teamsAll = $teamsHandler->getAllTeams($start, $limit);
	// Get All Teams
	$teams = [];
	foreach (\array_keys($teamsAll) as $i) {
		$team = $teamsAll[$i]->getValuesTeams();
		$acount = ['count', $count];
		$teams[] = \array_merge($team, $acount);
		$keywords[] = $teamsAll[$i]->getVar('tea_title');
		++$count;
	}
	$GLOBALS['xoopsTpl']->assign('teams', $teams);
	unset($teams);
	// Display Navigation
	if ($teamsCount > $limit) {
		include_once XOOPS_ROOT_PATH . '/class/pagenav.php';
		$pagenav = new \XoopsPageNav($teamsCount, $limit, $start, 'start', 'op=list&limit=' . $limit);
		$GLOBALS['xoopsTpl']->assign('pagenav', $pagenav->renderNav(4));
	}
	$GLOBALS['xoopsTpl']->assign('lang_thereare', \sprintf(_MA_TEAM_INDEX_THEREARE, $teamsCount));
	$GLOBALS['xoopsTpl']->assign('divideby', $helper->getConfig('divideby'));
	$GLOBALS['xoopsTpl']->assign('numb_col', $helper->getConfig('numb_col'));
}
unset($count);
$GLOBALS['xoopsTpl']->assign('table_type', $helper->getConfig('table_type'));
// Breadcrumbs
$xoBreadcrumbs[] = ['title' => _MA_TEAM_INDEX];
// Keywords
teamMetaKeywords($helper->getConfig('keywords') . ', ' . \implode(',', $keywords));
unset($keywords);
// Description
teamMetaDescription(_MA_TEAM_INDEX_DESC);
$GLOBALS['xoopsTpl']->assign('xoops_mpageurl', TEAM_URL.'/index.php');
$GLOBALS['xoopsTpl']->assign('xoops_icons32_url', XOOPS_ICONS32_URL);
$GLOBALS['xoopsTpl']->assign('team_upload_url', TEAM_UPLOAD_URL);
require __DIR__ . '/footer.php';
