<?php
/*
 You may not change or alter any portion of this comment or credits
 of supporting developers from this source code or any supporting source code
 which is considered copyrighted (c) material of the original comment or credit authors.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*/

/**
 * Team module for xoops
 *
 * @copyright      2020 XOOPS Project (https://xooops.org)
 * @license        GPL 2.0 or later
 * @package        team
 * @since          1.0
 * @min_xoops      2.5.9
 * @author         B.Heyula - Email:<b.heyula@hotmail.com> - Website:<http://erenyumak.com>
 */

// 
$moduleDirName      = \basename(__DIR__);
$moduleDirNameUpper = \mb_strtoupper($moduleDirName);
// ------------------- Informations ------------------- //
$modversion = [
	'name'                => _MI_TEAM_NAME,
	'version'             => 1.0,
	'description'         => _MI_TEAM_DESC,
	'author'              => 'B.Heyula',
	'author_mail'         => 'b.heyula@hotmail.com',
	'author_website_url'  => 'http://erenyumak.com',
	'author_website_name' => 'XOOPS Project',
	'credits'             => 'XOOPS Development Team',
	'license'             => 'GPL 2.0 or later',
	'license_url'         => 'http://www.gnu.org/licenses/gpl-3.0.en.html',
	'help'                => 'page=help',
	'release_info'        => 'release_info',
	'release_file'        => XOOPS_URL . '/modules/team/docs/release_info file',
	'release_date'        => '2020/11/12',
	'manual'              => 'link to manual file',
	'manual_file'         => XOOPS_URL . '/modules/team/docs/install.txt',
	'min_php'             => '7.0',
	'min_xoops'           => '2.5.9',
	'min_admin'           => '1.2',
	'min_db'              => ['mysql' => '5.6', 'mysqli' => '5.6'],
	'image'               => 'assets/images/logoModule.png',
	'dirname'             => \basename(__DIR__),
	'dirmoduleadmin'      => 'Frameworks/moduleclasses/moduleadmin',
	'sysicons16'          => '../../Frameworks/moduleclasses/icons/16',
	'sysicons32'          => '../../Frameworks/moduleclasses/icons/32',
	'modicons16'          => 'assets/icons/16',
	'modicons32'          => 'assets/icons/32',
	'demo_site_url'       => 'https://xoops.org',
	'demo_site_name'      => 'XOOPS Demo Site',
	'support_url'         => 'https://xoops.org/modules/newbb',
	'support_name'        => 'Support Forum',
	'module_website_url'  => 'www.xoops.org',
	'module_website_name' => 'XOOPS Project',
	'release'             => '2017-12-02',
	'module_status'       => 'Final',
	'system_menu'         => 1,
	'hasAdmin'            => 1,
	'hasMain'             => 1,
	'adminindex'          => 'admin/index.php',
	'adminmenu'           => 'admin/menu.php',
	'onInstall'           => 'include/install.php',
	'onUninstall'         => 'include/uninstall.php',
	'onUpdate'            => 'include/update.php',
];
// ------------------- Templates ------------------- //
$modversion['templates'] = [
	// Admin templates
	['file' => 'team_admin_about.tpl', 'description' => '', 'type' => 'admin'],
	['file' => 'team_admin_header.tpl', 'description' => '', 'type' => 'admin'],
	['file' => 'team_admin_index.tpl', 'description' => '', 'type' => 'admin'],
	['file' => 'team_admin_teams.tpl', 'description' => '', 'type' => 'admin'],
	['file' => 'team_admin_permissions.tpl', 'description' => '', 'type' => 'admin'],
	['file' => 'team_admin_footer.tpl', 'description' => '', 'type' => 'admin'],
	// User templates
	['file' => 'team_header.tpl', 'description' => ''],
	['file' => 'team_index.tpl', 'description' => ''],
	['file' => 'team_teams.tpl', 'description' => ''],
	['file' => 'team_teams_list.tpl', 'description' => ''],
	['file' => 'team_teams_item.tpl', 'description' => ''],
	['file' => 'team_breadcrumbs.tpl', 'description' => ''],
	['file' => 'team_footer.tpl', 'description' => ''],
];
// ------------------- Mysql ------------------- //
$modversion['sqlfile']['mysql'] = 'sql/mysql.sql';
// Tables
$modversion['tables'] = [
	'team_teams',
];
// ------------------- Menu ------------------- //
$currdirname  = isset($GLOBALS['xoopsModule']) && \is_object($GLOBALS['xoopsModule']) ? $GLOBALS['xoopsModule']->getVar('dirname') : 'system';
if ($currdirname == $moduleDirName) {
	$modversion['sub'][] = [
		'name' => _MI_TEAM_SMNAME1,
		'url'  => 'index.php',
	];
	// Sub teams
	$modversion['sub'][] = [
		'name' => _MI_TEAM_SMNAME2,
		'url'  => 'teams.php',
	];
	// Sub Submit
	$modversion['sub'][] = [
		'name' => _MI_TEAM_SMNAME3,
		'url'  => 'teams.php?op=new',
	];
}
// ------------------- Blocks ------------------- //
// Teams last
$modversion['blocks'][] = [
	'file'        => 'teams.php',
	'name'        => _MI_TEAM_TEAMS_BLOCK_LAST,
	'description' => _MI_TEAM_TEAMS_BLOCK_LAST_DESC,
	'show_func'   => 'b_team_teams_show',
	'edit_func'   => 'b_team_teams_edit',
	'template'    => 'team_block_teams.tpl',
	'options'     => 'last|5|25|0',
];
// Teams new
$modversion['blocks'][] = [
	'file'        => 'teams.php',
	'name'        => _MI_TEAM_TEAMS_BLOCK_NEW,
	'description' => _MI_TEAM_TEAMS_BLOCK_NEW_DESC,
	'show_func'   => 'b_team_teams_show',
	'edit_func'   => 'b_team_teams_edit',
	'template'    => 'team_block_teams.tpl',
	'options'     => 'new|5|25|0',
];
// Teams hits
$modversion['blocks'][] = [
	'file'        => 'teams.php',
	'name'        => _MI_TEAM_TEAMS_BLOCK_HITS,
	'description' => _MI_TEAM_TEAMS_BLOCK_HITS_DESC,
	'show_func'   => 'b_team_teams_show',
	'edit_func'   => 'b_team_teams_edit',
	'template'    => 'team_block_teams.tpl',
	'options'     => 'hits|5|25|0',
];
// Teams top
$modversion['blocks'][] = [
	'file'        => 'teams.php',
	'name'        => _MI_TEAM_TEAMS_BLOCK_TOP,
	'description' => _MI_TEAM_TEAMS_BLOCK_TOP_DESC,
	'show_func'   => 'b_team_teams_show',
	'edit_func'   => 'b_team_teams_edit',
	'template'    => 'team_block_teams.tpl',
	'options'     => 'top|5|25|0',
];
// Teams random
$modversion['blocks'][] = [
	'file'        => 'teams.php',
	'name'        => _MI_TEAM_TEAMS_BLOCK_RANDOM,
	'description' => _MI_TEAM_TEAMS_BLOCK_RANDOM_DESC,
	'show_func'   => 'b_team_teams_show',
	'edit_func'   => 'b_team_teams_edit',
	'template'    => 'team_block_teams.tpl',
	'options'     => 'random|5|25|0',
];
// ------------------- Config ------------------- //
// Editor Admin
\xoops_load('xoopseditorhandler');
$editorHandler = XoopsEditorHandler::getInstance();
$modversion['config'][] = [
	'name'        => 'editor_admin',
	'title'       => '_MI_TEAM_EDITOR_ADMIN',
	'description' => '_MI_TEAM_EDITOR_ADMIN_DESC',
	'formtype'    => 'select',
	'valuetype'   => 'text',
	'default'     => 'dhtml',
	'options'     => array_flip($editorHandler->getList()),
];
// Editor User
\xoops_load('xoopseditorhandler');
$editorHandler = XoopsEditorHandler::getInstance();
$modversion['config'][] = [
	'name'        => 'editor_user',
	'title'       => '_MI_TEAM_EDITOR_USER',
	'description' => '_MI_TEAM_EDITOR_USER_DESC',
	'formtype'    => 'select',
	'valuetype'   => 'text',
	'default'     => 'dhtml',
	'options'     => array_flip($editorHandler->getList()),
];
// Editor : max characters admin area
$modversion['config'][] = [
	'name'        => 'editor_maxchar',
	'title'       => '_MI_TEAM_EDITOR_MAXCHAR',
	'description' => '_MI_TEAM_EDITOR_MAXCHAR_DESC',
	'formtype'    => 'textbox',
	'valuetype'   => 'int',
	'default'     => 50,
];
// Get groups
$memberHandler = \xoops_getHandler('member');
$xoopsGroups  = $memberHandler->getGroupList();
$groups = [];
foreach ($xoopsGroups as $key => $group) {
	$groups[$group]  = $key;
}
// General access groups
$modversion['config'][] = [
	'name'        => 'groups',
	'title'       => '_MI_TEAM_GROUPS',
	'description' => '_MI_TEAM_GROUPS_DESC',
	'formtype'    => 'select_multi',
	'valuetype'   => 'array',
	'default'     => $groups,
	'options'     => $groups,
];
// Upload groups
$modversion['config'][] = [
	'name'        => 'upload_groups',
	'title'       => '_MI_TEAM_UPLOAD_GROUPS',
	'description' => '_MI_TEAM_UPLOAD_GROUPS_DESC',
	'formtype'    => 'select_multi',
	'valuetype'   => 'array',
	'default'     => $groups,
	'options'     => $groups,
];
// Get Admin groups
$crGroups = new \CriteriaCompo();
$crGroups->add(new \Criteria('group_type', 'Admin'));
$memberHandler = \xoops_getHandler('member');
$adminXoopsGroups  = $memberHandler->getGroupList($crGroups);
$adminGroups = [];
foreach ($adminXoopsGroups as $key => $adminGroup) {
	$adminGroups[$adminGroup]  = $key;
}
$modversion['config'][] = [
	'name'        => 'admin_groups',
	'title'       => '_MI_TEAM_ADMIN_GROUPS',
	'description' => '_MI_TEAM_ADMIN_GROUPS_DESC',
	'formtype'    => 'select_multi',
	'valuetype'   => 'array',
	'default'     => $adminGroups,
	'options'     => $adminGroups,
];
unset($crGroups);
// Keywords
$modversion['config'][] = [
	'name'        => 'keywords',
	'title'       => '_MI_TEAM_KEYWORDS',
	'description' => '_MI_TEAM_KEYWORDS_DESC',
	'formtype'    => 'textbox',
	'valuetype'   => 'text',
	'default'     => 'team, teams',
];
// create increment steps for file size
include_once __DIR__ . '/include/xoops_version.inc.php';
$iniPostMaxSize       = teamReturnBytes(\ini_get('post_max_size'));
$iniUploadMaxFileSize = teamReturnBytes(\ini_get('upload_max_filesize'));
$maxSize              = min($iniPostMaxSize, $iniUploadMaxFileSize);
if ($maxSize > 10000 * 1048576) {
	$increment = 500;
}
if ($maxSize <= 10000 * 1048576) {
	$increment = 200;
}
if ($maxSize <= 5000 * 1048576) {
	$increment = 100;
}
if ($maxSize <= 2500 * 1048576) {
	$increment = 50;
}
if ($maxSize <= 1000 * 1048576) {
	$increment = 10;
}
if ($maxSize <= 500 * 1048576) {
	$increment = 5;
}
if ($maxSize <= 100 * 1048576) {
	$increment = 2;
}
if ($maxSize <= 50 * 1048576) {
	$increment = 1;
}
if ($maxSize <= 25 * 1048576) {
	$increment = 0.5;
}
$optionMaxsize = [];
$i = $increment;
while ($i * 1048576 <= $maxSize) {
	$optionMaxsize[$i . ' ' . _MI_TEAM_SIZE_MB] = $i * 1048576;
	$i += $increment;
}
// Uploads : maxsize of image
$modversion['config'][] = [
	'name'        => 'maxsize_image',
	'title'       => '_MI_TEAM_MAXSIZE_IMAGE',
	'description' => '_MI_TEAM_MAXSIZE_IMAGE_DESC',
	'formtype'    => 'select',
	'valuetype'   => 'int',
	'default'     => 3145728,
	'options'     => $optionMaxsize,
];
// Uploads : mimetypes of image
$modversion['config'][] = [
	'name'        => 'mimetypes_image',
	'title'       => '_MI_TEAM_MIMETYPES_IMAGE',
	'description' => '_MI_TEAM_MIMETYPES_IMAGE_DESC',
	'formtype'    => 'select_multi',
	'valuetype'   => 'array',
	'default'     => ['image/gif', 'image/jpeg', 'image/png'],
	'options'     => ['bmp' => 'image/bmp','gif' => 'image/gif','pjpeg' => 'image/pjpeg', 'jpeg' => 'image/jpeg','jpg' => 'image/jpg','jpe' => 'image/jpe', 'png' => 'image/png'],
];
$modversion['config'][] = [
	'name'        => 'maxwidth_image',
	'title'       => '_MI_TEAM_MAXWIDTH_IMAGE',
	'description' => '_MI_TEAM_MAXWIDTH_IMAGE_DESC',
	'formtype'    => 'textbox',
	'valuetype'   => 'int',
	'default'     => 800,
];
$modversion['config'][] = [
	'name'        => 'maxheight_image',
	'title'       => '_MI_TEAM_MAXHEIGHT_IMAGE',
	'description' => '_MI_TEAM_MAXHEIGHT_IMAGE_DESC',
	'formtype'    => 'textbox',
	'valuetype'   => 'int',
	'default'     => 800,
];
// Admin pager
$modversion['config'][] = [
	'name'        => 'adminpager',
	'title'       => '_MI_TEAM_ADMIN_PAGER',
	'description' => '_MI_TEAM_ADMIN_PAGER_DESC',
	'formtype'    => 'textbox',
	'valuetype'   => 'int',
	'default'     => 10,
];
// User pager
$modversion['config'][] = [
	'name'        => 'userpager',
	'title'       => '_MI_TEAM_USER_PAGER',
	'description' => '_MI_TEAM_USER_PAGER_DESC',
	'formtype'    => 'textbox',
	'valuetype'   => 'int',
	'default'     => 10,
];
// Number column
$modversion['config'][] = [
	'name'        => 'numb_col',
	'title'       => '_MI_TEAM_NUMB_COL',
	'description' => '_MI_TEAM_NUMB_COL_DESC',
	'formtype'    => 'select',
	'valuetype'   => 'int',
	'default'     => 1,
	'options'     => [1 => '1', 2 => '2', 3 => '3', 4 => '4'],
];
// Divide by
$modversion['config'][] = [
	'name'        => 'divideby',
	'title'       => '_MI_TEAM_DIVIDEBY',
	'description' => '_MI_TEAM_DIVIDEBY_DESC',
	'formtype'    => 'select',
	'valuetype'   => 'int',
	'default'     => 1,
	'options'     => [1 => '1', 2 => '2', 3 => '3', 4 => '4'],
];
// Table type
$modversion['config'][] = [
	'name'        => 'table_type',
	'title'       => '_MI_TEAM_TABLE_TYPE',
	'description' => '_MI_TEAM_DIVIDEBY_DESC',
	'formtype'    => 'select',
	'valuetype'   => 'int',
	'default'     => 'bordered',
	'options'     => ['bordered' => 'bordered', 'striped' => 'striped', 'hover' => 'hover', 'condensed' => 'condensed'],
];
// Panel by
$modversion['config'][] = [
	'name'        => 'panel_type',
	'title'       => '_MI_TEAM_PANEL_TYPE',
	'description' => '_MI_TEAM_PANEL_TYPE_DESC',
	'formtype'    => 'select',
	'valuetype'   => 'text',
	'default'     => 'default',
	'options'     => ['default' => 'default', 'primary' => 'primary', 'success' => 'success', 'info' => 'info', 'warning' => 'warning', 'danger' => 'danger'],
];
// Advertise
$modversion['config'][] = [
	'name'        => 'advertise',
	'title'       => '_MI_TEAM_ADVERTISE',
	'description' => '_MI_TEAM_ADVERTISE_DESC',
	'formtype'    => 'textarea',
	'valuetype'   => 'text',
	'default'     => '',
];
// Bookmarks
$modversion['config'][] = [
	'name'        => 'bookmarks',
	'title'       => '_MI_TEAM_BOOKMARKS',
	'description' => '_MI_TEAM_BOOKMARKS_DESC',
	'formtype'    => 'yesno',
	'valuetype'   => 'int',
	'default'     => 0,
];
// Make Sample button visible?
$modversion['config'][] = [
	'name'        => 'displaySampleButton',
	'title'       => 'CO_' . $moduleDirNameUpper . '_' . 'SHOW_SAMPLE_BUTTON',
	'description' => 'CO_' . $moduleDirNameUpper . '_' . 'SHOW_SAMPLE_BUTTON_DESC',
	'formtype'    => 'yesno',
	'valuetype'   => 'int',
	'default'     => 1,
];
// Maintained by
$modversion['config'][] = [
	'name'        => 'maintainedby',
	'title'       => '_MI_TEAM_MAINTAINEDBY',
	'description' => '_MI_TEAM_MAINTAINEDBY_DESC',
	'formtype'    => 'textbox',
	'valuetype'   => 'text',
	'default'     => 'https://xoops.org/modules/newbb',
];
